#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

long long cube_root(long long x, bool flag)
{
	long long l = 0, r = 2000000;
	while (r - l > 1)
	{
		long long m = (r + l) / 2;
		if (m * m * m <= x)
			l = m;
		else
			r = m;
	}
	if (flag && (l * l * l < x))
		l++;
	return l;
}

long long square_root(long long x, bool flag)
{
	long long l = 0, r = 2000000000;
	while (r - l > 1)
	{
		long long m = (r + l) / 2;
		if (m * m <= x)
			l = m;
		else
			r = m;
	}
	if (flag && (l * l < x))
		l++;
	return l;
}


int main()
{
	long long a, b, k;
	cin >> a >> b >> k;

	long long cube_l = cube_root(a, true), cube_r = cube_root(b, false);

	//cout << cube_l << ' ' << cube_r << endl;

	long long square_l = square_root(a, true), square_r = square_root(b, false);
	//cout << square_l << ' ' << square_r << endl;
	
	long long ans = 0;
	for (long long i = cube_l; i <= cube_r; i++)
	{
		long long bl = max(square_l, square_root(i * i * i - k, true)), br = min(square_r, square_root(i * i * i + k, false));
		//cout << i << ' ' << bl << ' ' << br << endl;

		ans += (br - bl + 1);
	}

	cout << ans << endl;

	return 0;
}
