#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

struct query
{
	long long time, floor, ind;
	query *next, *prev;

	query(long long _time = 0, long long _floor = 0, long long _ind = 0)
	{
		time = _time;
		floor = _floor;
		ind = _ind;
		next = nullptr;
		prev = nullptr;
	}
};

bool comp(query q1, query q2)
{
	if ((q1.time < q2.time) || ((q1.time == q2.time) && (q1.floor < q2.floor)))
		return true;
	return false;
}

int main()
{
	long long n, m;
	cin >> n >> m;

	vector<long long> anses(n, 0);
	vector<query> Q(n);
	
	query* current = nullptr;
	for (long long i = 0; i < n; i++)
	{
		long long time, floor;
		cin >> time >> floor;
		Q[i] = query(time, floor, i);
	}

	for (int i = 0; i < n - 1; i++)
	{
		Q[i].next = &Q[i + 1];
		Q[i + 1].prev = &Q[i];
	}

	current = &Q[0];

	long long Lt = 0;
	while (current != nullptr)
	{
		long long T = max(current->time, Lt), F = current->floor;
		for (query* i = current; i != nullptr; i = i->next)
		{
			if (((T + F - 1 + F - i->floor - i->time >= 0)) && (i->floor <= F))
			{
				anses[i->ind] = T + 2 * F - 2;
				if (i->prev == nullptr)
				{
					current = i->next;
					if (current != nullptr)
						current->prev = nullptr;
				}
				else
				{
					(i->prev)->next = i->next;
				}
			}
		}
		
		Lt = T + 2 * F - 2;
	}

	for (long long i = 0; i < n; i++)
		cout << anses[i] << ' ';
	
	return 0;
}
