#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

vector<vector<int> > graph;
vector<bool> list;
vector<bool> used;
vector<long long> dist;

int main()
{
	int n;
	long long m;
	cin >> n >> m;

	graph.resize(n);
	list.assign(n, true);
	for (int i = 1; i <= n - 1; i++)
	{
		int v;
		cin >> v; v--;

		list[v] = false;
		graph[i].push_back(v);
		graph[v].push_back(i);
	}

	used.assign(n, false);
	dist.assign(n, 0);
	queue<int> Q;
	Q.push(0);
	used[0] = true;

	while (!Q.empty())
	{
		int v = Q.front();
		Q.pop();

		for (int i = 0; i < graph[v].size(); i++)
		{
			if (!used[graph[v][i]])
			{
				Q.push(graph[v][i]);
				dist[graph[v][i]] = dist[v] + 1;
				used[graph[v][i]] = true;
			}
		}
	}

	long long max1 = 0, max2 = 0;
	int n_lists = 0;

	for (int i = 0; i < n; i++)
	{
		if (list[i])
		{
			n_lists++;
			if (dist[i] >= max1)
			{
				max2 = max1;
				max1 = dist[i];
			}
			else if (dist[i] > max2)
			{
				max2 = dist[i];
			}
		}
	}

	if (n_lists == 1)
	{
		max1++;
		cout << max1 * m << endl;
	}
	else
	{
		max1++; max2++;
		cout << "!\n" << max1 * m + max2 + max1 * (m - 1) - 1 << endl;
	}


	return 0;
}