#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

vector<vector<int> > graph;
vector<bool> list;
vector<bool> used;
vector<long long> dist;

int main()
{
	int n;
	long long m;
	cin >> n >> m;

	graph.resize(n);
	list.assign(n, true);
	for (int i = 1; i <= n - 1; i++)
	{
		int v;
		cin >> v; v--;

		list[v] = false;
		graph[i].push_back(v);
		graph[v].push_back(i);
	}

	used.assign(n, false);
	dist.assign(n, 0);
	queue<int> Q;
	Q.push(0);
	used[0] = true;

	while (!Q.empty())
	{
		int v = Q.front();
		Q.pop();

		for (int i = 0; i < graph[v].size(); i++)
		{
			if (!used[graph[v][i]])
			{
				Q.push(graph[v][i]);
				dist[graph[v][i]] = dist[v] + 1;
				used[graph[v][i]] = true;
			}
		}
	}

	long long diametr = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		used.assign(n, false);
		dist.assign(n, 0);
		queue<int> Q;
		Q.push(i);
		used[i] = true;

		while (!Q.empty())
		{
			int v = Q.front();
			Q.pop();

			for (int i = 0; i < graph[v].size(); i++)
			{
				if (!used[graph[v][i]])
				{
					Q.push(graph[v][i]);
					dist[graph[v][i]] = dist[v] + 1;
					used[graph[v][i]] = true;
				}
			}
		}

		for (int i = 0; i < n; i++)
			diametr = max(diametr, dist[i]);
	}

	long long max1 = 0;
	int n_lists = 0;

	for (int i = 0; i < n; i++)
	{
		if (list[i])
		{
			n_lists++;
			max1 = max(max1, dist[i]);
		}
	}

	if (n_lists == 1)
	{
		diametr++; max1++;
		cout << max1 * m << endl;
	}
	else
	{
		diametr++; max1++;
		cout << diametr + max1 * (2 * m - 2) << endl;
	}


	return 0;
}