#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

vector<vector<int> > graph;
vector<bool> list;
vector<bool> used;
vector<long long> dist;

long long Dmetr = 0;

long long dfs(int v)
{
	used[v] = true;
	long long max1 = 1, max2 = 0;
	for (int i = 0; i < graph[v].size(); i++)
	{
		if (!used[graph[v][i]])
		{
			long long tmp = dfs(graph[v][i]) + 1;
			if (tmp >= max1)
			{
				max2 = max1;
				max1 = tmp;
			}
			else if (tmp > max2)
			{
				max2 = tmp;
			}
			if (max1 + max2 - 1 > Dmetr)
				Dmetr = max1 + max2 - 1;
		}
	}

	return max1;
}

int main()
{
	int n;
	long long m;
	cin >> n >> m;

	graph.resize(n);
	list.assign(n, true);
	for (int i = 1; i <= n - 1; i++)
	{
		int v;
		cin >> v; v--;

		list[v] = false;
		graph[i].push_back(v);
		graph[v].push_back(i);
	}

	used.assign(n, false);
	
	long long maxw = dfs(0);
	int n_lists = 0;

	for (int i = 0; i < n; i++)
	{
		if (list[i])
			n_lists++;	
	}

	if (n_lists == 1)
	{
		cout << maxw * m << endl;
	}
	else
	{
		cout << Dmetr + maxw * (2 * m - 2) << endl;
	}


	return 0;
}